<?php

include_once("IPaymentServiceInvoker.php5");    

class PaymentServiceInvokerBase implements IPaymentServiceInvoker
{
	protected $ws_nonce;
	protected $ws_timestamp;
	protected $ws_guid;
	protected $ws_msgid;
	protected $paymentId;
	protected $username;
	protected $password;
	
	/* IPaymentServiceInvoker members */
	public function GetPayments($merchantTransactionID, $isExecuted)
	{
		print_r("GetPayments method not implemented!");
		exit;
	}
	public function GetRedirectData($userID, $amount)
	{
		print_r("GetRedirectData not implemented!");
		exit;
	}
	/* end of IPaymentServiceInvoker members */
	
	// Generate WS-geader
	public function getWSHeader($action){
		
		// Login values
		$this->username = ConfigurationHelper::GetUsername();
		$this->password = ConfigurationHelper::GetPassword();
		
		$xml_header = ' <wsa:Action>http://www.cqrpayments.com/PaymentProcessing/'.$action.'</wsa:Action>'.
			' <wsa:MessageID>'.$this->ws_msgid.'</wsa:MessageID>'."\n".
			' <wsa:ReplyTo> '."\n".
			' <wsa:Address>http://schemas.xmlsoap.org/ws/2004/03/addressing/role/anonymous</wsa:Address> '."\n".
			' </wsa:ReplyTo> '."\n".         
			' <wsa:To>'.ConfigurationHelper::GetWebServicePath().'</wsa:To>'."\n".                                                                    
			' <wsse:Security soap:mustUnderstand="1">'."\n".
			'     <wsu:Timestamp wsu:Id="'.$this->ws_timestamp['id'].'">'."\n".
			'        <wsu:Created>'.$this->ws_timestamp['create'].'</wsu:Created>'."\n".
			'        <wsu:Expires>'.$this->ws_timestamp['expire'].'</wsu:Expires>'."\n".
			'     </wsu:Timestamp>'."\n".
			'     <wsse:UsernameToken xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" wsu:Id="'.$this->ws_guid.'">'."\n".
			'        <wsse:Username>'.$this->username.'</wsse:Username>'."\n".
			'        <wsse:Password Type="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText">'.$this->password.'</wsse:Password>'."\n".
			'        <wsse:Nonce>'.$this->ws_nonce.'</wsse:Nonce>'."\n".
			'        <wsu:Created>'.$this->ws_timestamp['create'].'</wsu:Created>'."\n".
			'     </wsse:UsernameToken>'."\n".
			' </wsse:Security>'."\n";  
		
		return $xml_header;          
	}
	
	// Assembles soap-request from header and body. Adds headers. Sends SOAP-request to CQR web-service
	public function AssembleAndSendSoapRequest($xml_body, $action){
		
		// Creation of WS-security header
		$xml_header = $this->getWSHeader($action);
		
		$xml =  '<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" '."\n".
			'                       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" '."\n".
			'                       xmlns:xsd="http://www.w3.org/2001/XMLSchema" '."\n".
			'                       xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing" '."\n".
			'                       xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"  '."\n".
			'                       xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"> '."\n".
			'           <soap:Header>'."\n".
			$xml_header .
			'           </soap:Header> '."\n".
			'           <soap:Body> '."\n".
			$xml_body .
			'           </soap:Body> '."\n".
			'</soap:Envelope>';                                                                
		
		//print_r($xml);exit;
		// get host name from URL
		$webServiceHost = preg_match('@^(?:https://)?([^/]+)@i', ConfigurationHelper::GetWebServicePath(), $matches);
		$webServiceHost = $matches[1];
		
		$webServiceEndpoint = str_replace($matches[0],"",ConfigurationHelper::GetWebServicePath())."/basic";
		
		$xml =
			'POST '.$webServiceEndpoint.' HTTP/1.0'."\r\n".
			'Host: '.$webServiceHost."\r\n".
			'Content-Type: text/xml; charset=utf-8'."\r\n".
			'Content-Length: '.strlen($xml)."\r\n".
			'SOAPAction: "http://www.cqrpayments.com/PaymentProcessing/'.$action.'"'."\r\n\r\n".
			$xml;
		
		$ch = curl_init();
		
		curl_setopt($ch, CURLOPT_URL, ConfigurationHelper::GetWebServicePath());
		curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $xml);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		
		$CQRresult = curl_exec($ch);            
		
		$cErr = curl_error($ch);
		
		if($cErr != ''){
			$err = 'cURL ERROR: '.curl_errno($ch).': '.$cErr.'<br>';
			foreach(curl_getinfo($ch) as $k => $v){
				$err .= "$k: $v<br>";
			}
			echo $err;
			curl_close($ch);
			exit;
		}
		// close curl
		curl_close($ch);
		
		return $CQRresult;
	}
	
	// Assembles xml-request. Sends POX-request to CQR web-service
	public function AssembleAndSendPOXRequest($xml, $action){
		// Login values
		$this->username = ConfigurationHelper::GetUsername();
		$this->password = ConfigurationHelper::GetPassword();
		
		// get host name from URL
		$webServiceHost = preg_match('@^(?:https://)?([^/]+)@i', ConfigurationHelper::GetWebServicePath(), $matches);
		$webServiceHost = $matches[1];
		
		$webServiceEndpoint = str_replace($matches[0],"",ConfigurationHelper::GetWebServicePath())."/pox/".$action;
		
		$xml =
			'POST '.$webServiceEndpoint.' HTTP/1.1'."\r\n".
			'Content-Type: application/xml; charset=utf-8'."\r\n".						
			'Authorization: Basic '.base64_encode($this->username.":".$this->password)."\r\n".						
			'Host: '.$webServiceHost."\r\n".
			'Content-Length: '.strlen($xml)."\r\n".
			'Expect: 100-continue'."\r\n".
			'Connection: Keep-Alive'."\r\n\r\n".
			$xml;
		
		$ch = curl_init();
		
		curl_setopt($ch, CURLOPT_URL, ConfigurationHelper::GetWebServicePath());
		curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $xml);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		
		$CQRresult = curl_exec($ch);            
		
		$cErr = curl_error($ch);
		
		if($cErr != ''){
			$err = 'cURL ERROR: '.curl_errno($ch).': '.$cErr.'<br>';
			foreach(curl_getinfo($ch) as $k => $v){
				$err .= "$k: $v<br>";
			}
			echo $err;
			curl_close($ch);
			exit;
		}
		// close curl
		curl_close($ch);
		
		return $CQRresult;  
	}
	// set of WS header data
	public function setWSData() {
		
		// Ws header values            
		$this->ws_nonce      = $this->generate_nonce();  
		$this->ws_timestamp  = $this->generate_timedata();
		$this->ws_guid       = $this->generate_guid_value();
		$this->ws_msgid      = $this->generate_messageID();
		$this->paymentId     = $this->generate_paymentID();              
	}
	
	// generation of nonce
	private function generate_nonce(){
		
		$rand_value = rand(100000,999999);
		$nonce =  base64_encode(md5($rand_value));      
		
		return $nonce; 
	}
	
	// generation of a new Payment ID
	function generate_paymentID(){
		
		$rand_value = rand();
		
		$paymentId = md5(uniqid($rand_value, true));
		$paymentId = substr($paymentId,  0,  7) . "-" .
			substr($paymentId,  7,  4) . "-" .
			substr($paymentId, 11,  4) . "-" .
			substr($paymentId, 15,  4) . "-" .
			substr($paymentId, 19, 10);
		
		return $paymentId;
	}
	
	// generation of timestamp
	private function generate_timedata(){
		
		$datetime = gmdate('Y-m-d')." ".gmdate('H:i:s')."";
		$datetime = new DateTime($datetime);
		$stamp['create'] = str_replace(' ', 'T', $datetime->format('Y-m-d H:i:s'))."Z";        
		$datetime->modify("+5 minutes");
		
		$stamp['expire'] = str_replace(' ', 'T', $datetime->format('Y-m-d H:i:s'))."Z";
		
		$prefix = 'Timestamp' . "-";
		$tid = md5(uniqid(rand(), true));
		$stamp['id'] = $prefix . substr($tid,  0,  8) . "-" .
			substr($tid,  8,  4) . "-" .
			substr($tid, 12,  4) . "-" .
			substr($tid, 16,  4) . "-" .
			substr($tid, 20, 12);
		return($stamp);
	}
	
	
	// generation of GUID
	private function generate_guid_value(){
		
		$prefix = "SecurityToken-";
		
		$rand_value = md5(uniqid(rand(), true));
		
		$return = $prefix . substr($rand_value,  0,  8) . "-" .
			substr($rand_value,  8,  4) . "-" .
			substr($rand_value, 12,  4) . "-" .
			substr($rand_value, 16,  4) . "-" .
			substr($rand_value, 20, 12);
		return($return);
	}
	
	
	
	// generation of unique message system id
	function generate_messageID(){
		
		$prefix = "uuid:";
		$rand_value = md5(uniqid(rand(), true));
		$return = $prefix . substr($rand_value,  0,  8) . "-" .
			substr($rand_value,  8,  4) . "-" .
			substr($rand_value, 12,  4) . "-" .
			substr($rand_value, 16,  4) . "-" .
			substr($rand_value, 20, 12);
		return($return);
	}
	
	public function xml2array(&$string) {
		$parser = xml_parser_create();
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parse_into_struct($parser, $string, $vals, $index);
		xml_parser_free($parser);
		
		$mnary=array();
		$ary=&$mnary;
		foreach ($vals as $r) {
			//print_r($mnary);echo "<br>";
			$t=$r['tag'];
			if ($r['type']=='open') {
				if (isset($ary[$t])) {
					if (isset($ary[$t][0])) $ary[$t][]=array(); else $ary[$t]=array($ary[$t], array());
					$cv=&$ary[$t][count($ary[$t])-1];
				} else $cv=&$ary[$t];
				if (isset($r['attributes'])) {foreach ($r['attributes'] as $k=>$v) $cv['_a'][$k]=$v;}
				$cv['_c']=array();
				$cv['_c']['_p']=&$ary;
				$ary=&$cv['_c'];
				
			} elseif ($r['type']=='complete') {
				if (isset($ary[$t])) { // same as open
					if (isset($ary[$t][0])) $ary[$t][]=array(); else $ary[$t]=array($ary[$t], array());
					$cv=&$ary[$t][count($ary[$t])-1];
				} else $cv=&$ary[$t];
				if (isset($r['attributes'])) {foreach ($r['attributes'] as $k=>$v) $cv['_a'][$k]=$v;}
				$cv['_v']=(isset($r['value']) ? $r['value'] : '');
				
			} elseif ($r['type']=='close') {
				$ary=&$ary['_p'];
			}
		}    
		
		$this->_del_p($mnary);
		return $mnary;
	}
	// _Internal: Remove recursion in result array
	private function _del_p(&$ary) {
		foreach ($ary as $k=>$v) {
			if ($k==='_p') unset($ary[$k]);
			elseif (is_array($ary[$k])) $this->_del_p($ary[$k]);
		}
	}
}

// represents return value
class redirectData
{
	protected $redirectUrlField;
	protected $dataFields;
	
	public function __construct($redirectUrl,$dataFields)
	{
		$this->redirectUrlField  = $redirectUrl;
		
		$this->dataFields = array(id=>"requestData",value=>$dataFields);
	}
	public function getUrl(){
		return $this->redirectUrlField;
	}
	public function getDataFields(){
		return $this->dataFields;
	}                
	
}
?>