<?php

include_once("Components/paymentRepository.php5");
include_once("Components/configurationHelper.php5");     
require_once("Components/paymentServiceInvokerFactory.php5");     

$paymentResultsProcessingStrategy = ConfigurationHelper::GetPaymentResultsProcessingStrategy();   
$accessStrategy = ConfigurationHelper::GetWebserviceAccessStrategy();

$isExecuted = false;

if($paymentResultsProcessingStrategy == "push"){
	
	$paymentID = $_GET["PID"];
	if(!$paymentID) $paymentID = $_POST["PID"];
	
	if($paymentID){
		$processor = new PaymentProcessor();
		$state = $processor->getPaymentState($paymentID);
		if($state)
			$isExecuted = true;
	}
}

if($paymentResultsProcessingStrategy == "pull"){   
	$paymentID = $_GET["PID"];
	$amount = $_GET["am"]/100;
	$fee = $_GET["fee"]/100;
	
	$client = PaymentServiceInvokerFactory::getPaymentServiceInvoker($accessStrategy);	
	$response = $client->getPayments($paymentID,"");                              
	
	$i=1;
	if(count($response) < 1) 
		$actual_message = "No payments were received";
	else{
		$isPaymentProcessedSuccessfully = false;
		foreach($response as $payment){
			if(($paymentID == $payment["_c"]["merchantTransactionID"]["_v"]) &&
					(strtolower($payment["_c"]["isExecuted"]["_v"]) == "true") && // true means money were really transfered to user account. If you need check only that payment was created successfully delete this condition.
					($amount == $payment["_c"]["amount"]["_v"]) &&
					($fee == $payment["_c"]["shopFee"]["_v"])){
				
				$isExecuted = true;
				break;
			} 	 
		}
		//$actual_message = $isPaymentProcessedSuccessfully ? "Payment was processed successfully. Your product/service will be shipped/can be consumed immediately." : "Payment was NOT processed successfully. Some error occured during payment processing!";   		
	}    
}

$timeout = 5000;   
$processing_message = "Thank you for the payment. Processing payment, page will be refreshed in ".($timeout/1000)." seconds...";
$approved_message = "Payment processed successfully. Your products will be shipped immediately.";
$declined_message = "Your payment could not be processed!";
$actual_message = $processing_message;

$refreshCount = (int)$_POST["refreshCount"];
$isRefresh = 0;

if($isExecuted)
{
	$actual_message = $approved_message;
}
else
{
	if($refreshCount < 5){
		$refreshCount ++;   
		$isRefresh = 1;
	}  else{
		$actual_message = $declined_message;
	}
}  
 ?>     
     
<HTML>
  <HEAD>
        <title>PaymentServiceIntegrationSample</title>
  </HEAD>
    <body>
        <form id="Form1" name="Form1" method="post">    
            <label ID="infoLabel" Font-Bold="true" ><? echo $actual_message;?></label>                
            <input id="refreshCount" type="hidden" name="refreshCount" value="<?echo $refreshCount;?>"/>
        </form>
    </body>    
    <script type="text/javascript">
        function doRefresh(){
           document.Form1.submit();
        }
        <? if($isRefresh) echo "window.setTimeout('doRefresh()',".$timeout.");";?>
    </script>
</HTML>     